/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include <visa.h>

ViStatus rsrtm_InitAttributes (ViSession vi);
ViStatus rsrtm_DefaultInstrSetup (ViSession openInstrSession);
ViStatus rsrtm_CheckStatus (ViSession vi);
ViStatus rsrtm_CheckStatusTimed (ViSession instrSession);
ViStatus rsrtm_CheckTimedStatusCallback (ViSession vi);
ViStatus rsrtm_WaitForOPC (ViSession vi, ViUInt32 maxTime);
ViInt32 rsrtm_StringIndex(ViString array[], ViChar buff[]); 
ViStatus rsrtm_readBinaryDataBlock (ViSession instrSession,
                                  /*@out@*/ViChar **outputBuffer, /*@out@*/ViUInt32 *byteCount);
ViBoolean rsrtm_invalidViInt32Range (ViInt32 val, ViInt32 min, ViInt32 max);
ViBoolean rsrtm_invalidViUInt32Range (ViUInt32 val, ViUInt32 min, ViUInt32 max);
ViBoolean rsrtm_invalidViReal64Range (ViReal64 val, ViReal64 min, ViReal64 max);
ViBoolean rsrtm_invalidViBooleanRange (ViBoolean val);
//ViStatus rsrtm_ReadDataUnknownLength(ViSession instrSession, /*@out@*/ViChar **outBuffer, /*@out@*/ViUInt32 *count);
ViStatus rsrtm_ParseCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
ViStatus rsrtm_ParseLimitLineCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
void rsrtm_SWAP_32(unsigned char *data, long points);  
void rsrtm_SWAP_16(unsigned char *data, long points);
ViStatus rsrtm_dataReadTrace (ViSession instrSession,
                                 ViString trace, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus rsrtm_dataReadTraceOnly (ViSession instrSession,
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus rsrtm_dataAsciiReadTrace (ViSession instrSession,
                                 ViInt32 window,
                                 ViString trace, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus _VI_FUNC rsrtm_dataReadTraceIQ (ViSession   instrSession,
                                            ViInt32     bufferSize,
                                            ViPInt32    noofPoints,
                                            /*@out@*/ViReal64 _VI_FAR realPartsI[],
                                            /*@out@*/ViReal64 _VI_FAR imaginaryPartsQ[]);                                 
ViStatus rsrtm_SetOPCTimeout(ViSession   instrSession, ViInt32 timeout);
ViStatus rsrtm_GetOPCTimeout(ViSession   instrSession, ViInt32 *timeout);
ViStatus rsrtm_CheckBeforeRead (ViSession instrSession, ViUInt32 maxTime);
ViStatus rsrtm_ClearBeforeRead (ViSession instrSession);
ViStatus rsrtm_WaitForOPCCallback (ViSession io);
ViStatus rsrtm_GetAttributeRepCapName (ViSession instrSession,
                                ViUInt32 attributeID,
                                ViString repCapNameId,
                                ViInt32 value,
                                ViInt32 bufferSize,
                                ViChar _VI_FAR repCapName[]);
ViBoolean rsrtm_CheckOption (ViSession instrSession, ViString option);
